Index: /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Core/3.3/NamedItem.cs	(revision 2664)
@@ -0,0 +1,148 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Core {
+  [Item("NamedItem", "Base class for items which have a name and an optional description.")]
+  public abstract class NamedItem : Item, INamedItem {
+    [Storable]
+    protected string name;
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="OnNameChanging"/> and also <see cref="OnNameChanged"/> 
+    /// eventually in the setter.</remarks>
+    public string Name {
+      get { return name; }
+      set {
+        if (!CanChangeName) throw new NotSupportedException("Name of NamedItem cannot be changed.");
+        if (value == null) throw new ArgumentNullException();
+        if (!name.Equals(value)) {
+          CancelEventArgs<string> e = new CancelEventArgs<string>(value);
+          OnNameChanging(e);
+          if (!e.Cancel) {
+            name = value;
+            OnNameChanged();
+          }
+        }
+      }
+    }
+    public virtual bool CanChangeName {
+      get { return true; }
+    }
+    [Storable]
+    protected string description;
+    public string Description {
+      get { return description; }
+      set {
+        if (!CanChangeDescription) throw new NotSupportedException("Description of NamedItem cannot be changed.");
+        if ((description == null) || (!description.Equals(value))) {
+          description = value;
+          OnDescriptionChanged();
+        }
+      }
+    }
+    public virtual bool CanChangeDescription {
+      get { return true; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="Variable"/> with name <c>Anonymous</c> 
+    /// and value <c>null</c>.
+    /// </summary>
+    protected NamedItem() {
+      name = ItemName;
+      description = ItemDescription;
+    }
+    /// <summary>
+    /// Initializes a new instance of <see cref="Variable"/> with the specified <paramref name="name"/>
+    /// and the specified <paramref name="value"/>.
+    /// </summary>
+    /// <param name="name">The name of the current instance.</param>
+    /// <param name="value">The value of the current instance.</param>
+    protected NamedItem(string name)
+      : this() {
+      if (name == null) throw new ArgumentNullException();
+      this.name = name;
+    }
+    protected NamedItem(string name, string description)
+      : this(name) {
+      this.description = description;
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="Variable"/>.</returns>
+    public override IDeepCloneable Clone(Cloner cloner) {
+      NamedItem clone = (NamedItem)base.Clone(cloner);
+      clone.name = name;
+      clone.description = description;
+      return clone;
+    }
+
+    /// <summary>
+    /// Gets the string representation of the current instance in the format: <c>Name: [null|Value]</c>.
+    /// </summary>
+    /// <returns>The current instance as a string.</returns>
+    public override string ToString() {
+      return Name;
+    }
+
+    /// <inheritdoc/>
+    public event EventHandler<CancelEventArgs<string>> NameChanging;
+    /// <summary>
+    /// Fires a new <c>NameChanging</c> event.
+    /// </summary>
+    /// <param name="e">The event arguments of the changing.</param>
+    protected virtual void OnNameChanging(CancelEventArgs<string> e) {
+      if (NameChanging != null)
+        NameChanging(this, e);
+    }
+    /// <inheritdoc/>
+    public event EventHandler NameChanged;
+    /// <summary>
+    /// Fires a new <c>NameChanged</c> event.
+    /// </summary>
+    /// <remarks>Calls <see cref="ItemBase.OnChanged"/>.</remarks>
+    protected virtual void OnNameChanged() {
+      if (NameChanged != null)
+        NameChanged(this, new EventArgs());
+      OnChanged();
+    }
+    /// <inheritdoc/>
+    public event EventHandler DescriptionChanged;
+    /// <summary>
+    /// Fires a new <c>DescriptionChanged</c> event.
+    /// </summary>
+    /// <remarks>Calls <see cref="ItemBase.OnChanged"/>.</remarks>
+    protected virtual void OnDescriptionChanged() {
+      if (DescriptionChanged != null)
+        DescriptionChanged(this, new EventArgs());
+      OnChanged();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/NamedItemCollection.cs	(revision 2664)
@@ -30,5 +30,5 @@
 
 namespace HeuristicLab.Core {
-  public class NamedItemCollection<T> : ObservableKeyedCollectionBase<string, T>, IDeepCloneable where T : class, INamedItem {
+  public class NamedItemCollection<T> : ObservableKeyedCollection<string, T>, IDeepCloneable where T : class, INamedItem {
     [Storable(Name = "RestoreEvents")]
     private object RestoreEvents {
Index: /trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 2664)
@@ -35,5 +35,5 @@
   [Item("OperatorGraph", "Represents a graph of operators.")]
   [Creatable("Test")]
-  public class OperatorGraph : ItemBase {
+  public class OperatorGraph : Item {
     private OperatorSet operators;
     /// <summary>
Index: /trunk/sources/HeuristicLab.Core/3.3/OperatorParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/OperatorParameter.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/OperatorParameter.cs	(revision 2664)
@@ -34,5 +34,5 @@
   [EmptyStorableClass]
   [Creatable("Test")]
-  public class OperatorParameter : Parameter<IOperator>, IOperatorParameter {
+  public class OperatorParameter : ItemParameter<IOperator>, IOperatorParameter {
     public OperatorParameter()
       : base("Anonymous", null) {
Index: /trunk/sources/HeuristicLab.Core/3.3/Parameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Parameter.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/Parameter.cs	(revision 2664)
@@ -31,122 +31,35 @@
   /// Represents a parameter.
   /// </summary>
-  [Item("Parameter", "A parameter which represents an IItem.")]
-  [Creatable("Test")]
-  public class Parameter : ParameterBase {
-    [Storable]
-    private string actualName;
-    public string ActualName {
-      get { return actualName; }
-      set {
-        if (value == null) throw new ArgumentNullException();
-        if (!actualName.Equals(value)) {
-          actualName = value;
-          OnActualNameChanged();
-        }
-      }
+  [Item("Parameter", "A base class for parameters.")]
+  public abstract class Parameter : NamedItem, IParameter {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public override bool CanChangeDescription {
+      get { return false; }
     }
 
-    private IItem value;
     [Storable]
-    public IItem Value {
-      get { return this.value; }
-      set {
-        if (value != this.value) {
-          if ((value != null) && (!DataType.IsInstanceOfType(value))) throw new ArgumentException("Static value does not match data type of parameter");
-          if (this.value != null) this.value.Changed -= new ChangedEventHandler(Value_Changed);
-          this.value = value;
-          if (this.value != null) this.value.Changed += new ChangedEventHandler(Value_Changed);
-          OnValueChanged();
-        }
-      }
+    private Type dataType;
+    public Type DataType {
+      get { return dataType; }
     }
 
-    public Parameter()
-      : base("Anonymous", null, typeof(IItem)) {
-      actualName = Name;
-      Value = null;
+    protected Parameter()
+      : base("Anonymous") {
+      dataType = typeof(IItem);
     }
     protected Parameter(string name, string description, Type dataType)
-      : base(name, description, dataType) {
-      this.actualName = Name;
-      this.Value = null;
-    }
-    public Parameter(string name, string description)
-      : base(name, description, typeof(IItem)) {
-      this.actualName = Name;
-      this.Value = null;
-    }
-    public Parameter(string name, string description, IItem value)
-      : base(name, description, typeof(IItem)) {
-      this.actualName = Name;
-      this.Value = value;
+      : base(name, description) {
+      if (dataType == null) throw new ArgumentNullException();
+      this.dataType = dataType;
     }
 
-    public override IItem GetValue(ExecutionContext context) {
-      if (Value != null) return Value;
-      ExecutionContext parent = context.Parent;
-      IParameter parameter = null;
-
-      while ((parent != null) && (parameter == null)) {
-        parent.Operator.Parameters.TryGetValue(ActualName, out parameter);
-        parent = parent.Parent;
-      }
-
-      if (parameter != null) return parameter.GetValue(context);
-      else return context.Scope.Lookup(ActualName, true).Value;
-    }
+    public abstract IItem GetValue(ExecutionContext context);
 
     public override IDeepCloneable Clone(Cloner cloner) {
       Parameter clone = (Parameter)base.Clone(cloner);
-      clone.actualName = actualName;
-      clone.Value = (IItem)cloner.Clone(value);
+      clone.dataType = dataType;
       return clone;
-    }
-
-    public override string ToString() {
-      return string.Format("{0}: {1} ({2})", Name, Value != null ? Value.ToString() : ActualName, DataType.Name);
-    }
-
-    public event EventHandler ActualNameChanged;
-    private void OnActualNameChanged() {
-      if (ActualNameChanged != null)
-        ActualNameChanged(this, new EventArgs());
-      OnChanged();
-    }
-    public event EventHandler ValueChanged;
-    private void OnValueChanged() {
-      if (ValueChanged != null)
-        ValueChanged(this, new EventArgs());
-      OnChanged();
-    }
-
-    private void Value_Changed(object sender, ChangedEventArgs e) {
-      OnChanged(e);
-    }
-  }
-
-  [Item("Parameter<T>", "A generic parameter which represents an instance of type T.")]
-  [EmptyStorableClass]
-  public class Parameter<T> : Parameter where T : class, IItem {
-    public new T Value {
-      get { return (T)base.Value; }
-      set { base.Value = value; }
-    }
-
-    public Parameter()
-      : base("Anonymous", null, typeof(T)) {
-      Value = null;
-    }
-    public Parameter(string name, string description)
-      : base(name, description, typeof(T)) {
-      this.Value = null;
-    }
-    public Parameter(string name, string description, T value)
-      : base(name, description, typeof(T)) {
-      this.Value = value;
-    }
-
-    public new T GetValue(ExecutionContext context) {
-      return (T)base.GetValue(context);
     }
   }
Index: /trunk/sources/HeuristicLab.Core/3.3/Scope.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/Scope.cs	(revision 2664)
@@ -33,5 +33,5 @@
   [Item("Scope", "A scope which contains variables and sub-scopes.")]
   [Creatable("Test")]
-  public class Scope : NamedItemBase {
+  public class Scope : NamedItem {
     [Storable]
     private Scope parent;
Index: /trunk/sources/HeuristicLab.Core/3.3/Variable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 2664)
@@ -33,5 +33,5 @@
   [Item("Variable", "A variable which has a name and holds an IItem.")]
   [Creatable("Test")]
-  public sealed class Variable : NamedItemBase {
+  public sealed class Variable : NamedItem {
     private IItem value;
     /// <inheritdoc/>
Index: /trunk/sources/HeuristicLab.Data.Views/3.3/IntDataView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data.Views/3.3/IntDataView.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Data.Views/3.3/IntDataView.cs	(revision 2664)
@@ -35,5 +35,5 @@
   /// </summary>
   [Content(typeof(IntData), true)]
-  public partial class IntDataView : ItemViewBase {
+  public partial class IntDataView : ItemView {
     public IntData IntData {
       get { return (IntData)Item; }
Index: /trunk/sources/HeuristicLab.Data/3.3/ValueTypeData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ValueTypeData.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Data/3.3/ValueTypeData.cs	(revision 2664)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Data {
   [Item("ValueTypeData<T>", "A base class for representing value types.")]
-  public class ValueTypeData<T> : ItemBase where T : struct {
+  public class ValueTypeData<T> : Item where T : struct {
     [Storable]
     protected T value;
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 2663)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 2664)
@@ -52,9 +52,9 @@
   <ItemGroup>
     <Compile Include="HeuristicLabOperatorsViewsPlugin.cs" />
-    <Compile Include="OperatorBaseView.cs">
+    <Compile Include="OperatorView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="OperatorBaseView.Designer.cs">
-      <DependentUpon>OperatorBaseView.cs</DependentUpon>
+    <Compile Include="OperatorView.Designer.cs">
+      <DependentUpon>OperatorView.cs</DependentUpon>
     </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.Designer.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.Designer.cs	(revision 2664)
@@ -0,0 +1,96 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Operators.Views {
+  partial class OperatorView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
+      this.SuspendLayout();
+      // 
+      // nameTextBox
+      // 
+      this.nameTextBox.Size = new System.Drawing.Size(418, 20);
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.descriptionTextBox.Size = new System.Drawing.Size(418, 90);
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.parameterCollectionView.Caption = "ParameterCollection";
+      this.parameterCollectionView.ItemCollection = null;
+      this.parameterCollectionView.Location = new System.Drawing.Point(0, 122);
+      this.parameterCollectionView.Name = "parameterCollectionView";
+      this.parameterCollectionView.NamedItemCollection = null;
+      this.parameterCollectionView.Size = new System.Drawing.Size(490, 231);
+      this.parameterCollectionView.TabIndex = 4;
+      // 
+      // OperatorBaseView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.parameterCollectionView);
+      this.Name = "OperatorBaseView";
+      this.Size = new System.Drawing.Size(490, 353);
+      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.descriptionLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    protected HeuristicLab.Core.Views.ParameterCollectionView parameterCollectionView;
+
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.cs	(revision 2664)
@@ -0,0 +1,68 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Operators.Views { 
+  /// <summary>
+  /// The base class for visual representations of items.
+  /// </summary>
+  [Content(typeof(Operator), true)]
+  public partial class OperatorView : NamedItemView {
+    public Operator OperatorBase {
+      get { return (Operator)base.Item; }
+      set { base.Item = value; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="ItemBaseView"/>.
+    /// </summary>
+    public OperatorView() {
+      InitializeComponent();
+    }
+    /// <summary>
+    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
+    /// </summary>
+    /// <param name="item">The item that should be displayed.</param>
+    public OperatorView(Operator operatorBase)
+      : this() {
+      OperatorBase = operatorBase;
+    }
+
+    protected override void OnObjectChanged() {
+      base.OnObjectChanged();
+      if (OperatorBase == null) {
+        parameterCollectionView.NamedItemCollection = null;
+      } else {
+        parameterCollectionView.NamedItemCollection = ((IOperator)OperatorBase).Parameters;
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs	(revision 2664)
@@ -34,5 +34,5 @@
   [Creatable("Test")]
   [EmptyStorableClass]
-  public sealed class EmptyOperator : StandardOperatorBase {
+  public sealed class EmptyOperator : StandardOperator {
     public EmptyOperator()
       : base() {
Index: /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2663)
+++ /trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2664)
@@ -89,7 +89,7 @@
     </Compile>
     <Compile Include="HeuristicLabOperatorsPlugin.cs" />
-    <Compile Include="OperatorBase.cs" />
+    <Compile Include="Operator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="StandardOperatorBase.cs" />
+    <Compile Include="StandardOperator.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2664)
@@ -0,0 +1,156 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using System.Drawing;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// The base class for all operators.
+  /// </summary>
+  [Item("Operator", "Base class for operators.")]
+  public abstract class Operator : NamedItem, IOperator {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Method; }
+    }
+
+    private ParameterCollection parameters;
+    [Storable]
+    protected ParameterCollection Parameters {
+      get { return parameters;}
+      private set {
+        if (parameters != null) parameters.Changed -= new ChangedEventHandler(Parameters_Changed);
+        parameters = value;
+        readOnlyParameters = null;
+        if (parameters != null) parameters.Changed += new ChangedEventHandler(Parameters_Changed);
+      }
+    }
+    private ReadOnlyObservableKeyedCollection<string, IParameter> readOnlyParameters;
+    IObservableKeyedCollection<string, IParameter> IOperator.Parameters {
+      get {
+        if (readOnlyParameters == null) readOnlyParameters = parameters.AsReadOnly();
+        return readOnlyParameters;
+      }
+    }
+
+    /// <summary>
+    /// Flag whether the current instance has been canceled.
+    /// </summary>
+    private bool canceled;
+    /// <inheritdoc/>
+    protected bool Canceled {
+      get { return canceled; }
+    }
+
+    [Storable]
+    private bool breakpoint;
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="OnBreakpointChanged"/> in the setter.</remarks>
+    public bool Breakpoint {
+      get { return breakpoint; }
+      set {
+        if (value != breakpoint) {
+          breakpoint = value;
+          OnBreakpointChanged();
+        }
+      }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorBase"/> setting the breakpoint flag and 
+    /// the canceled flag to <c>false</c> and the name of the operator to the type name. 
+    /// </summary>
+    protected Operator() {
+      name = ItemName;
+      Parameters = new ParameterCollection();
+      readOnlyParameters = null;
+      canceled = false;
+      breakpoint = false;
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Clones also sub operators, variables and variable infos.</remarks>
+    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="OperatorBase"/>.</returns>
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Operator clone = (Operator)base.Clone(cloner);
+      clone.Parameters = (ParameterCollection)cloner.Clone(parameters);
+      clone.canceled = canceled;
+      clone.breakpoint = breakpoint;
+      return clone;
+    }
+
+    /// <inheritdoc/>
+    public virtual ExecutionContextCollection Execute(ExecutionContext context) {
+      canceled = false;
+      ExecutionContextCollection next = Apply(context);
+      OnExecuted();
+      return next;
+    }
+    /// <inheritdoc/>
+    /// <remarks>Sets property <see cref="Canceled"/> to <c>true</c>.</remarks>
+    public virtual void Abort() {
+      canceled = true;
+    }
+    /// <summary>
+    /// Performs the current operator on the specified <paramref name="scope"/>.
+    /// </summary>
+    /// <param name="scope">The scope where to execute the operator</param>
+    /// <returns><c>null</c>.</returns>
+    public virtual ExecutionContextCollection Apply(ExecutionContext context) {
+      return new ExecutionContextCollection();
+    }
+
+    /// <inheritdoc/>
+    public event EventHandler BreakpointChanged;
+    /// <summary>
+    /// Fires a new <c>BreakpointChanged</c> event.
+    /// </summary>
+    protected virtual void OnBreakpointChanged() {
+      if (BreakpointChanged != null) {
+        BreakpointChanged(this, new EventArgs());
+      }
+      OnChanged();
+    }
+    /// <inheritdoc/>
+    public event EventHandler Executed;
+    /// <summary>
+    /// Fires a new <c>Executed</c> event.
+    /// </summary>
+    protected virtual void OnExecuted() {
+      if (Executed != null) {
+        Executed(this, new EventArgs());
+      }
+    }
+
+    private void Parameters_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/StandardOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/StandardOperator.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Operators/3.3/StandardOperator.cs	(revision 2664)
@@ -0,0 +1,54 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// A base class for operators which have only one successor.
+  /// </summary>
+  [Item("Standard Operator", "A base class for operators which have only one successor.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public abstract class StandardOperator : Operator {
+    public OperatorParameter Successor {
+      get { return (OperatorParameter)Parameters["Successor"]; }
+    }
+
+    public StandardOperator()
+      : base() {
+      Parameters.Add(new OperatorParameter("Successor", "Operator which is executed next"));
+    }
+
+    public override ExecutionContextCollection Apply(ExecutionContext context) {
+      IOperator successor = Successor.GetValue(context);
+      if (successor != null)
+        return new ExecutionContextCollection(new ExecutionContext(context.Parent, successor, context.Scope));
+      else
+        return new ExecutionContextCollection();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.SequentialEngine/3.3/SequentialEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.SequentialEngine/3.3/SequentialEngine.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.SequentialEngine/3.3/SequentialEngine.cs	(revision 2664)
@@ -34,5 +34,5 @@
   [Creatable("Engines")]
   [Item("Sequential Engine", "Engine for sequential execution of algorithms.")]
-  public class SequentialEngine : EngineBase {
+  public class SequentialEngine : Engine {
     private IOperator currentOperator;
 
